package palmbible.output;

import java.io.*;
import java.util.*;

import palmbible.parser.*;
import palmbible.util.*;

public class MoNoonDoc extends GenericDoc
{
	protected Template verseTP;
	protected Template titleTP;

	public MoNoonDoc(BibleDoc bibleDoc, String docName) throws Exception
	{
		super(bibleDoc, docName);

		setTemplatePackage("/template/monoon/");
		
		titleTP 	= getTemplate("title.dat");
		verseTP 	= getTemplate("verse.dat");

		encode = "UTF8";
		generate();
	}

	protected void beginBible(Map wordMap) throws Exception
	{
		System.out.println("Making MoNoon Files ...");

		setOutputDir(docName + "/monoon/");
		setOutputFile("title.dat", "title.dat");
	}

	protected void endBible(Map wordMap) throws Exception
	{
		wordMap.put("%%bookname%%", "Bible");
		print(titleTP.getString(wordMap), "title.dat");

		wordMap.put("%%bookname%%", "Old Testament");
		print(titleTP.getString(wordMap), "title.dat");

		wordMap.put("%%bookname%%", "New Testament");
		print(titleTP.getString(wordMap), "title.dat");

		outputFile("ver.dat", wordMap);

		System.out.println("MoNoon Files Generated ...");
		System.out.println();
	}
	
	protected void beginBook(Map wordMap) throws Exception
	{
		int bookNum = Integer.parseInt((String) wordMap.get("%%booknum%%"));
		int bookSeq = Integer.parseInt((String) wordMap.get("%%bookseq%%"));

		if (bookSeq > 66){
			setOutputFile("ignore.dat");
		} else {
			setOutputFile("vol" + bookSeq + ".dat");
			print(titleTP.getString(wordMap), "title.dat");
		}
	}
	
	protected void verseText(Map wordMap) throws Exception
	{
		print(verseTP.getString(wordMap));
	}
}
