/*****************************************************************************

    Bible Converter for Bible Reader
    Copyright (C) 2001  Poetry H.C. Poon
    
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    
    You may contact Poetry H.C. Poon at poetry@hongkong.com

*****************************************************************************/

package palmbible.parser;

public class Chapter extends Parser
{
	protected static final String TAG_NAME = "CHAPTER";
	protected static final String VERSE_START = "VERSSTART";

	public Chapter(Tokenizer tokenizer, WordRecorder wordRecorder) throws Exception
	{
		checkTag(tokenizer);

		int start = getIntAttrib(VERSE_START);
		for (int i=1; i < start; i++){
			addChild(new Verse());
		}

		parse(tokenizer, wordRecorder);
	}
	
	public Chapter() throws Exception
	{
		addChild(new Verse());
	}
	
	public int getTotalVerse()
	{
		return getTotalChild();
	}

	public Verse getVerse(int index)
	{
		return (Verse) getChild(index);
	}

	public String getTagName()
	{
		return TAG_NAME;
	}

	protected Object parseChild(Tokenizer tokenizer, WordRecorder wordRecorder) throws Exception
	{
		return new Verse(tokenizer, wordRecorder);
	}
}
