/*****************************************************************************

    Bible Converter for Bible Reader
    Copyright (C) 2001  Poetry H.C. Poon
    
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    
    You may contact Poetry H.C. Poon at poetry@hongkong.com

*****************************************************************************/

package palmbible.parser;

public class Token
{
	protected Tag tag;
	protected String string;

	protected String prevString1;
	protected String prevString2;
	protected int line;

	public Token(String string, String prevString1, String prevString2, int line)
	{
		this(prevString1, prevString2, line);
		this.string = string;
		this.tag = null;
	}

	public Token(Tag tag, String prevString1, String prevString2, int line)
	{
		this(prevString1, prevString2, line);
		this.tag = tag;
		this.string = null;
	}

	protected Token(String prevString1, String prevString2, int line)
	{
		this.prevString1 = prevString1;
		this.prevString2 = prevString2;
		this.line = line;
	}

	public boolean isTag()
	{
		return tag != null;
	}
	
	public Tag getTag()
	{
		return tag;
	}
	
	public int getLine()
	{
		return line;
	}
	
	public String toString()
	{
		if (tag == null){
			return string;
		} else {
			return tag.toString();
		}
	}

	public String getErrorMessage(String message)
	{
		if (isTag()){
			return message + " : " + tag.toString() + " : ... at line " + line;
		} else {
			return message + " : " + string + " : ... " 
				+ prevString2 + " " + prevString1 + string + " ... at line " + line;
		}
	}
}
