/*****************************************************************************

    Bible Converter for Bible Reader
    Copyright (C) 2001  Poetry H.C. Poon
    
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    
    You may contact Poetry H.C. Poon at poetry@hongkong.com

*****************************************************************************/

package palmbible.pdbfile;

import palmbible.parser.*;
import palmbible.util.*;

public class BookIndexRecord extends PDBRecord
{
	public BookIndexRecord(Book book)
	{
		int totalChapter = book.getTotalChapter();
		content.addShort(totalChapter);
		
		int totalVerseAcc = 0;
		int totalChapterCharAcc = 0;
		
		ByteBuffer verseCharBuffer = new ByteBuffer();
		ByteBuffer chapterCharBuffer = new ByteBuffer();

		for (int i=0; i<totalChapter; i++){
			int totalChapterChar = 0;

			chapterCharBuffer.addInt(totalChapterCharAcc);

			Chapter chapter = book.getChapter(i);
			int totalVerse = chapter.getTotalVerse();
			totalVerseAcc += totalVerse;
			
			content.addShort(totalVerseAcc);
			
			int totalVerseCharAcc = 0;
			
			for (int j=0; j<totalVerse; j++){
				Verse verse = chapter.getVerse(j);
				int totalVerseChar = verse.getTotalCompressedChar();
				totalVerseCharAcc += totalVerseChar;
				verseCharBuffer.addShort(totalVerseCharAcc);
			}

			totalChapterCharAcc += totalVerseCharAcc;
		}
		
		content.addByteBuffer(chapterCharBuffer);
		content.addByteBuffer(verseCharBuffer);
	}
}
