/*****************************************************************************

    Bible Reader for Palm
    Copyright (C) 2001  Ho Chuen Poon
    
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    
    You may contact Ho Chuen Poon at poetry@hongkong.com

*****************************************************************************/

#include <PalmOS.h>
#include "PalmBible.h"
#include "PalmBible_res.h"

static Boolean mnuVersionInfo_OnSelect(UInt16 menuID)
{
	FrmPopupForm(frmVersionInfo);
	return true;
}

static Boolean mnuDeleteVer_OnSelect(UInt16 menuID)
{
	FrmPopupForm(frmDeleteVer);
	return true;
}

static SECT1 Boolean mnuSearch_OnSelect(UInt16 menuID)
{
	gotoSearch();
	return true;
}

static SECT1 Boolean mnuBack_OnSelect(UInt16 menuID)
{
	HtyBackHistory();
	FrmUpdateForm(frmMain, viewUpdateCode);
	return true;
}

static SECT1 Boolean mnuForward_OnSelect(UInt16 menuID)
{
	HtyForwardHistory();
	FrmUpdateForm(frmMain, viewUpdateCode);
	return true;
}

static SECT1 Boolean mnuGoto_OnSelect(UInt16 menuID)
{
	FrmPopupForm(frmGoto);
	return true;
}

static SECT1 Boolean mnuBookmark_OnSelect(UInt16 menuID)
{
	FrmPopupForm(frmBookmark);
	return true;
}

static SECT1 Boolean mnuPreferences_OnSelect(UInt16 menuID)
{
	FrmPopupForm(frmPref);
	return true;
}

static SECT1 Boolean mnuAbout_OnSelect(UInt16 menuID)
{
	FrmPopupForm(frmAbout);
	return true;
}

Boolean ApplicationHandleMenu(UInt16 menuID)
{
	Boolean handled = false;

	switch (menuID)
	{
		case mnuVersionInfo:
			handled = mnuVersionInfo_OnSelect(menuID);
			break;
		case mnuDeleteVer:
			handled = mnuDeleteVer_OnSelect(menuID);
			break;
		case mnuSearch:
			handled = mnuSearch_OnSelect(menuID);
			break;
		case mnuBack:
			handled = mnuBack_OnSelect(menuID);
			break;
		case mnuForward:
			handled = mnuForward_OnSelect(menuID);
			break;
		case mnuGoto:
			handled = mnuGoto_OnSelect(menuID);
			break;
		case mnuBookmark:
			handled = mnuBookmark_OnSelect(menuID);
			break;
		case mnuPreferences:
			handled = mnuPreferences_OnSelect(menuID);
			break;
		case mnuAbout:
			handled = mnuAbout_OnSelect(menuID);
			break;
		default:
			break;
	}

	return handled;
}
