/*****************************************************************************

    Bible Reader for Palm
    Copyright (C) 2001  Ho Chuen Poon
    
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    
    You may contact Ho Chuen Poon at poetry@hongkong.com

*****************************************************************************/

// Structure Definition

typedef struct ConfigType {
	UInt16 lineSpace;
	UInt16 wordSpace;
	Boolean noBlankNormal;
	Boolean noBlankDual;
	Boolean nothing;

	RGBColorType bookColor;
	RGBColorType descColor;
	RGBColorType chapterColor;
	RGBColorType verseColor;
	RGBColorType textColor;

	Boolean boldBook;
	Boolean boldDesc;
	Boolean boldChapter;
	Boolean boldVerse;
	Boolean boldText;
	Boolean useVBold;
	
	Boolean dualView;
	ViewerType upperViewer;
	ViewerType lowerViewer;

	Boolean inSearch;
	UInt16 searchVersion;
	BookmarkType searchFrom;
	BookmarkType searchTo;
	BookmarkType searchProgress;
	UInt16 resultLine;
	BookmarkType result[totalResultLine];
	
	UInt16 lastTotalVersion;
} ConfigType;
typedef ConfigType *ConfigPtr;

// Public Functions

void CfgOpenConfig() SECT1;
void CfgCloseConfig() SECT1;
void CfgSetDefaultVersion() SECT1;
