/*****************************************************************************

    Bible Reader for Palm
    Copyright (C) 2001  Ho Chuen Poon
    
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    
    You may contact Ho Chuen Poon at poetry@hongkong.com

*****************************************************************************/

#define dmxConfigType 'cnfg'
#define dmxVersionType 'bibl'

#define dmxTotalBufferRecord 8
#define dmxVersionLimit 12

// Structure Definition

struct LockRecordType;
typedef struct LockRecordType *LockRecordPtr;
typedef struct LockRecordType {
	DmOpenRef dmxLockRef;
	MemHandle dmxLockHandle;
	UInt16 dmxLockIndex;
	LockRecordPtr prev;
} LockRecordType;

// Public Functions
void DmxOpenDatabase();
void DmxCloseDatabase();
DmOpenRef DmxOpenConfig(char* name);
void DmxUncacheVersion(UInt16 version);
void* DmxLockVersionRecord(UInt16 version, UInt16 record);
void DmxUnlockVersionRecord(UInt16 version, UInt16 record);
void DmxAddRecord(DmOpenRef dbRef, UInt16 recIndex, void* rec, UInt16 size);
void* DmxLockRecord(DmOpenRef dbRef, UInt16 recIndex);
void DmxUnlockRecord();
UInt16 DmxGetTotalVersions();

