/*****************************************************************************

    Bible Reader for Palm
    Copyright (C) 2001  Ho Chuen Poon
    
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    
    You may contact Ho Chuen Poon at poetry@hongkong.com

*****************************************************************************/

#include <PalmOS.h>
#include "PalmBible.h"
#include "PalmBible_res.h"   

static Boolean deletedVersion;
static ListContainPtr fdvVersionList;
static UInt16 totalVerstion;

static Boolean frmDeleteVer_cmdDelete_OnSelect(EventPtr event)
{
	UInt16 selection, i;
	selection = getListSelection(lstVersion, fdvVersionList);
	
	if (totalVerstion > 1){ 
		if (selection > 0 && FrmAlert(altDelete) == 0){
			DmxDeleteVersion(selection);
			deletedVersion = true;
		
			i = getListIndex(fdvVersionList, selection);
			fdvVersionList->numList[i] = 0;
			StrCopy(fdvVersionList->nameList[i], "-"); 
		
			setListChoices(lstVersion, fdvVersionList);
			
			totalVerstion --;
		}
	} else {
		FrmAlert(altLastVersion);
	}
	return true;
}

static Boolean frmDeleteVer_cmdClose_OnSelect(EventPtr event)
{
	DmxOpenDatabase();

	if (deletedVersion){
		CfgSetDefaultVersion();
		FrmAlert(altExit);
		restart = true;
	} else {
		FrmReturnToForm(frmMain);
	}
	
	return true;
}

static Boolean frmDeleteVer_OnClose(EventPtr event)
{
	return false;
}

static Boolean frmDeleteVer_OnOpen(EventPtr event)
{
	modalForm = FrmGetActiveForm();
	FrmDrawForm(modalForm);
	
	deletedVersion = false;
	
	fdvVersionList = InfGetVersionList();
	totalVerstion = fdvVersionList->totalValue; 

	setListChoices(lstVersion, fdvVersionList);
	setListSelection(lstVersion, fdvVersionList, -1);

	DmxCloseDatabase();

	return true;
}

Boolean frmDeleteVer_HandleEvent(EventPtr event)
{
	FormPtr form;
	Boolean handled = false;

	switch (event->eType)
	{
		case ctlSelectEvent:
			switch (event->data.ctlSelect.controlID)
			{
				case cmdClose:
					handled = frmDeleteVer_cmdClose_OnSelect(event);
					break;
				case cmdDelete:
					handled = frmDeleteVer_cmdDelete_OnSelect(event);
					break;
			}
			break;
		case frmCloseEvent:
			handled = frmDeleteVer_OnClose(event);
			break;
		case frmOpenEvent:
			handled = frmDeleteVer_OnOpen(event);
			break;
	}

	return handled;
}
