/*****************************************************************************

    Bible Reader for Palm
    Copyright (C) 2001  Ho Chuen Poon
    
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    
    You may contact Ho Chuen Poon at poetry@hongkong.com

*****************************************************************************/

#include <PalmOS.h>
#include "PalmBible.h"
#include "PalmBible_res.h"   

static MemHandle versionInfoHandle;

static SECT1 Boolean frmVersionInfo_sclVersionInfo_OnChange(EventPtr event)
{
	Int16 scrollValue;

	scrollValue = event->data.sclRepeat.newValue - event->data.sclRepeat.value;
	
	if (scrollValue < 0){
		scrollField(fldVersionInfo, -scrollValue, winUp);
	} else {
		scrollField(fldVersionInfo, scrollValue, winDown);
	}

	return false;
}

static SECT1 Boolean frmVersionInfo_cmdClose_OnSelect(EventPtr event)
{
	FrmReturnToForm(frmMain);

	return true;
}

Boolean frmVersionInfo_OnOpen(EventPtr event)
{
	UInt16 index, totalVersion, i;
	char* versionInfoPtr;
	char* versionName;
	char* versionInfo;

	modalForm = FrmGetActiveForm();
	FrmDrawForm(modalForm);
	
	versionInfoHandle = MemHandleNew(2048);
	versionInfoPtr = MemHandleLock(versionInfoHandle);

	index = 0;
	totalVersion = DmxGetTotalVersions();
	
	for (i=0; i< totalVersion; i++){
		versionName = InfGetVersionName(i + 1);
   		versionInfo = InfGetVersionInfo(i + 1);

		if (StrLen(versionName) > 0 && StrLen(versionInfo) > 0){
    		StrCopy(&versionInfoPtr[index], versionName);
    		index += StrLen(versionName);
    		versionInfoPtr[index] = '\n';
    		index ++;
    		versionInfoPtr[index] = 0;

    		StrCopy(&versionInfoPtr[index], versionInfo);
    		index += StrLen(versionInfo);
    		versionInfoPtr[index] = '\n';
    		index ++;

    		versionInfoPtr[index] = '\n';
    		index ++;
			
    		versionInfoPtr[index] = 0;
		}

   		MemPtrFree(versionName);
		MemPtrFree(versionInfo);
	}
	
	if (index > 0){
		index -= 2;
   		versionInfoPtr[index] = 0;
	}
	
	MemHandleUnlock(versionInfoHandle);
	
	setField(fldVersionInfo, versionInfoHandle);
	setFieldScrollValue(fldVersionInfo, sclVersionInfo);

	setControlUsable(sclVersionInfo, true);
	
    return false;
}

Boolean frmVersionInfo_OnClose(EventPtr event)
{
    return false;
}

Boolean frmVersionInfo_HandleEvent(EventPtr event)
{
	Boolean handled = false;

	switch (event->eType)
	{
		case sclRepeatEvent :
			switch (event->data.ctlSelect.controlID)
			{
				case sclVersionInfo:
					handled = frmVersionInfo_sclVersionInfo_OnChange(event);
					break;
			}
			break;
		case ctlSelectEvent:
			switch (event->data.ctlSelect.controlID)
			{
				case cmdClose:
					handled = frmVersionInfo_cmdClose_OnSelect(event);
					break;
			}
			break;
		case frmOpenEvent:
			handled = frmVersionInfo_OnOpen(event);
			break;
		case frmCloseEvent:
			handled = frmVersionInfo_OnClose(event);
			break;
		default:
			break;
	}
    
	return handled;
}
